﻿class Coolboy : IMapper
{
    public string Name { get => "AA6023B submapper 13 (365-in-1)"; }
    public int Number { get => 268; }
    public byte Submapper { get => 13; }
    public string UnifName { get => null; }
    public int DefaultPrgSize { get => 64 * 1024 * 1024; }
    public int DefaultPrgRamSize { get => 8 * 1024; }
    public int DefaultChrRamSize { get => 256 * 1024; }

    public void DumpPrg(IFamicomDumperConnection dumper, List<byte> data, int size)
    {
        dumper.Reset();
        int banks = size / 0x20000;

        for (var bank = 0; bank < banks; bank++)
        {
            var r0 = (byte)(
                0xC0 |
                (bank & 0x07) // 6, 5, 4 bits
            );
            var r1a = (byte)(
                ((bank >> 4) & 1) // 8
                | ((bank >> 2) & 0x78) // 12, 11, 10, 9
            );
            var r1b = (byte)(
                0x90
                | (bank & 0x08) // 7
            );
            var r2 = (byte)0;
            var r3 = (byte)0;
            dumper.WriteCpu(0x5000, r0);
            dumper.WriteCpu(0x5001, (byte)(r1a | 0x04));
            dumper.WriteCpu(0x5001, (byte)(r1a | 0x06));
            dumper.WriteCpu(0x5001, (byte)(r1a | 0x04));
            dumper.WriteCpu(0x5001, (byte)(r1b | 0x04));
            dumper.WriteCpu(0x5002, r2, r3);

            Console.Write($"Reading PRG bank #{bank}/{banks}... ");
            for (int i = 0; i < 16; i++)
            {
                dumper.WriteCpu(0x8000, (byte)6, (byte)i);
                data.AddRange(dumper.ReadCpu(0x8000, 0x2000));
            }
            Console.WriteLine("OK");
        }
    }

    public void EnablePrgRam(IFamicomDumperConnection dumper)
    {
        dumper.Reset();
        dumper.WriteCpu(0xA001, 0x00);
        dumper.WriteCpu(0x5003, 0x80);
        dumper.WriteCpu(0xA001, 0x80);
    }

    public MirroringType GetMirroring(IFamicomDumperConnection dumper)
    {
        return MirroringType.MapperControlled;
    }
}
